<?php
/*
 * $Horde: whups/create.php,v 1.15 2002/02/20 18:01:23 chuck Exp $
 *
 * Copyright 2001 Robert E. Coyle <robertecoyle@hotmail.com>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/bsdl.php.
 */

define('WHUPS_BASE', dirname(__FILE__));
require_once WHUPS_BASE . '/lib/base.php';
require_once WHUPS_BASE . '/lib/Create.php';

require WHUPS_TEMPLATES . '/common.inc';
require WHUPS_TEMPLATES . '/page.inc';
require WHUPS_TEMPLATES . '/headerbar.inc';
require WHUPS_TEMPLATES . '/formrenderer.inc';
require WHUPS_TEMPLATES . '/actionresult.inc';

useForms(array(
    'CreateStep1Form',
    'CreateStep2Form',
    'CreateStep3Form'));

$PAGE         = new Page();
$HEADERBAR    = new HeaderBar();
$RENDERER     = new FormRenderer();
$ACTIONRESULT = new ActionResult();

$empty      = '';
$beendone   = 0;
$wereerrors = 0;

$vars = &getDefaultVars($empty);
$formname = $vars->getVar('formname');

// start the page
$PAGE->open(_("Create Tickets"));
$HEADERBAR->header($sections, 'create');
$HEADERBAR->actions($sections, 'create');

$form1 = &getCreateStep1Form($vars);
$form2 = &getCreateStep2Form($vars);
$form3 = &getCreateStep3Form($vars);

$form1->validate($vars);
$form2->validate($vars);
$form3->validate($vars);

if (!$form3->isValid() || !$form2->isValid() || !$form1->isValid()) {
    if ($form2->isValid() && $form1->isValid()) {
        $form3->open($RENDERER, $vars, 'create.php', 'post');

        // render the stage 1 form readonly
        $form1->preserve($vars);
        $RENDERER->beginInactive('Create Ticket - Stage 1');
        $RENDERER->renderFormInactive($form1, $vars);
        $RENDERER->end();

        // render the stage 2 form readonly
        $form2->preserve($vars);
        $RENDERER->beginInactive('Create Ticket - Stage 2');
        $RENDERER->renderFormInactive($form2, $vars);
        $RENDERER->end();

        // render the third stage form
        if ($formname != 'createstep3form') {
            $form3->clearValidation();
        }
        $RENDERER->beginActive("Create Ticket - Stage 3");
        $RENDERER->renderFormActive($form3, $vars);
        $RENDERER->submit();
        $RENDERER->end();

        $form2->close($RENDERER);

        $beendone = 1;
    } else {
        if ($form1->isValid()) {
            $form2->open($RENDERER, $vars, 'create.php', 'post');
            
            // render the original form readonly
            $form1->preserve($vars);
            $RENDERER->beginInactive('Create Ticket - Stage 1');
            $RENDERER->renderFormInactive($form1, $vars);
            $RENDERER->end();
            
            // render the second stage form
            if ($formname != 'createstep2form') {
                $form2->clearValidation();
            }
            $RENDERER->beginActive("Create Ticket - Stage 2");
            $RENDERER->renderFormActive($form2, $vars);
            $RENDERER->submit();
            $RENDERER->end();

            $form2->close($RENDERER);

            $beendone = 1;
        } else {
            if ($formname != 'createstep1form') {
                $form1->clearValidation();
            }
            $form1->open($RENDERER, $vars, 'create.php', 'post');
            $RENDERER->beginActive(_("Create Ticket - Stage 1"));
            $RENDERER->renderFormActive($form1, $vars);
            $RENDERER->submit();
            $RENDERER->end();
            $form1->close($RENDERER);
        }
    }
} else {
    $form1->getInfo($vars, $info);
    $form2->getInfo($vars, $info);
    $form3->getInfo($vars, $info);
    $results = $backend->addTicket($info);
    $tid = $results[0];
    $message = sprintf(_("Your ticket id is %s. "), $tid);
    $message .= _("An appropriate person has been notified of this request.\n");
    $message .= sprintf(_("Your ticket details are available at %s the details page"), '<a href="' . Horde::url('details.php?id=' . $tid) . '">') . '</a>';
    $ACTIONRESULT->result(_("Create Ticket"), 1, $message);
    $beendone = 1;
}

$PAGE->close();

?>
