<?php
/*
 * $Horde: whups/details.php,v 1.15 2002/01/25 00:37:53 chuck Exp $
 *
 * Copyright 2001 Robert E. Coyle <robertecoyle@hotmail.com>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/bsdl.php.
 */

define('WHUPS_BASE', dirname(__FILE__));
require_once WHUPS_BASE . '/lib/base.php';
require_once WHUPS_BASE . '/lib/Forms.php';
require_once WHUPS_BASE . '/lib/Search.php';

require WHUPS_TEMPLATES . '/common.inc';
require WHUPS_TEMPLATES . '/page.inc';
require WHUPS_TEMPLATES . '/headerbar.inc';
require WHUPS_TEMPLATES . '/actions.inc';
require WHUPS_TEMPLATES . '/formrenderer.inc';
require WHUPS_TEMPLATES . '/comment.inc';
require WHUPS_TEMPLATES . '/useractions.inc';
require WHUPS_TEMPLATES . '/actionresult.inc';

$useForm = array('TicketDetailsForm',
                 'AddCommentForm',
                 'AssignTicketForm',
                 'SetStateForm',
                 'SetPriorityForm');

useForms($useForm);

$PAGE = new Page();
$HEADERBAR = new HeaderBar();
$RENDERER = new FormRenderer();
$COMMENT = new Comment();
$ACTIONRESULT = new ActionResult();

$beendone = 0;

$vars = &getDefaultVars();
$beendone = 0;
$info = array();

$ticket = $vars->getVarWasset('id', $wasset);
$action = $vars->getVar('action');
$from = $vars->getVar('formname');

// ticket actions
$ACTIONS = new Actions();
$ACTIONS->addAction(_("Add Comment"),   'details.php', 'ac');
$ACTIONS->addAction(_("Assign Ticket"), 'details.php', 'at');
$ACTIONS->addAction(_("Set State"),     'details.php', 'ss');
$ACTIONS->addAction(_("Set Priority"),  'details.php', 'sp');
$ACTIONS->preserve('id', $ticket);

// start the page
$PAGE->open(_("Ticket details"));
$HEADERBAR->header($sections, 'search');
$HEADERBAR->actions($sections, 'search');

// get the ticket details first
$details = $backend->getTicketDetails($ticket);

// we use info about the ticket in the forms below
$vars = new WhupsVars($details, $vars);

/////// Add Comment action

if ($from == 'addcommentform') {
    $addform = &getAddCommentForm($vars);
    $addform->validate($vars);

    if ($addform->isValid()) {
        $addform->getInfo($vars, $info);
        $backend->addComment($info);
        $ACTIONRESULT->result(_("Add Comment"), 1);
        $action = '';
    } else {
        $action = 'ac';
    }
}

//////// Assign Ticket action

if ($from == 'assignticketform') {
    $assignform = &getAssignTicketForm($vars);
    $assignform->validate($vars);

    if ($assignform->isValid()) {
        $assignform->getInfo($vars, $info);
        $backend->assignTicket($info);
        $details = $backend->getTicketDetails($ticket);
        $ACTIONRESULT->result(_("Assign Ticket"), 1);
        $action = '';
    } else {
        $action = 'at';
    }
}

//////// Set State action

if ($from == 'setstateform') {
    $setstateform = &getSetStateForm($vars);
    $setstateform->validate($vars);

    if ($setstateform->isValid()) {
        $setstateform->getInfo($vars, $info);
        $backend->setTicketState($info);
        $details = $backend->getTicketDetails($ticket);
        $ACTIONRESULT->result(_("Set Ticket State"), 1);
        $action = '';
    } else {
        $action = 'ss';
    }
}

//////// Set Priority action

if ($from == 'setpriorityform') {
    $setpriorityform = &getSetPriorityForm($vars);
    $setpriorityform->validate($vars);

    if ($setpriorityform->isValid()) {
        $setpriorityform->getInfo($vars, $info);
        $backend->setTicketPriority($info);
        $details = $backend->getTicketDetails($ticket);
        $ACTIONRESULT->result(_("Set Ticket Priority"), 1);
        $action = '';
    } else {
        $action = 'sp';
    }
}

//////// Main ticket details page

if (!$beendone) {
    $form = null;

    switch ($action) {
    case 'ac': $form = &getAddCommentForm($vars); break;
    case 'at': $form = &getAssignTicketForm($vars); break;
    case 'ss': $form = &getSetStateForm($vars); break;
    case 'sp': $form = &getSetPriorityForm($vars); break;
    }

    $title = $ACTIONS->getTitleFromAction($action);

    if ($form != null) {
        $form->open($RENDERER, $vars, 'details.php', 'post');
        $RENDERER->beginActive($title);
        $RENDERER->renderFormActive($form, $vars);
        $RENDERER->submit();
        $RENDERER->end();
        $form->close($RENDERER);
    }

    $form = &getTicketDetailsForm($vars);

    $RENDERER->beginInactive(sprintf(_("Ticket %s Details"), $ticket));
    $RENDERER->renderFormInactive($form, new WhupsVars($details, $empty));
    $RENDERER->end();

    $comments = $backend->getComments($ticket);

    $COMMENT->begin(sprintf(_("Ticket %s Comments"), $ticket));

    foreach ($comments as $key => $comment_values) {
        $COMMENT->render(new WhupsVars($comment_values, $empty));
    }

    $COMMENT->end();
    $ACTIONS->render($action);
}

$PAGE->close();

?>
