<?php
/*
 * $Horde: whups/lib/Create.php,v 1.17 2002/03/02 19:16:40 chuck Exp $
 *
 * Copyright 2001 Robert E. Coyle <robertecoyle@hotmail.com>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/bsdl.php.
 */

require_once WHUPS_BASE . '/lib/Forms.php';

/**
 * CreateStep1Form Class
 *
 * @author Robert E. Coyle <robertecoyle@hotmail.com>
 * @version $Revision: 1.17 $
 * @package whups
 */
class CreateStep1Form extends Form {

    function CreateStep1Form(&$vars)
    {
        global $backend;

        $this->Form($vars, 'createstep1form', null, $vars);

        $modules = $backend->getModules();
        $modtype = new EnumType($modules);

        $var1 = new Variable(_("Module Name"), 'module', $modtype, true);

        $this->addVariable($var1);
    }

}

class CreateStep2Form extends Form {

    function CreateStep2Form(&$vars)
    {
        global $backend;

        $this->Form($vars, 'createstep2form', null, $vars);

        $types = $backend->getTypes($vars->getVar('module'));
        if (count($types) == 0) {
            $typetype = new InvalidType(_("There are no ticket types associated with this module; until there are, you cannot create any tickets in this module."));
        } else {
            $typetype = new EnumType($types);
        }

        $var1 = new Variable(_("Ticket Type"), 'type', $typetype, true);

        $this->addVariable($var1);
    }

}

class CreateStep3Form extends Form {

    function CreateStep3Form(&$vars)
    {
        global $backend;

        $this->Form($vars, 'createstep3form');

        $states = $backend->getStates($vars->getVar('type'), 'unconfirmed');
        
        $module = $vars->getVar('module');
        $info = $backend->getModule($module);

        if (!empty($info['subjectlist'])) {
            $subjects = $backend->getModuleSubjectNames($module);
            $subtype = new EnumType($subjects);
        } else {
            $subtype = getTextType();
        }

        if (!Auth::isGuest()) {
            $states2 = $backend->getStates($vars->getVar('type'), 'new');
            if (is_array($states2)) {
                $states = $states + $states2;
            }
        }

        $priorities = $backend->getPriorities($vars->getVar('type'));

        $statetype = new EnumType($states);
        $prioritiestype = new EnumType($priorities);

        $var1 = new Variable(_("Ticket State"), 'state', $statetype, true);
        $var2 = new Variable(_("Priority"), 'priority', $prioritiestype, true);
        $var3 = new Variable(_("Summary"), 'summary', $subtype, true);
        $var4 = new Variable(_("Description"), 'comment', getLongTextType(), true);

        $this->addVariable($var1);
        $this->addVariable($var2);
        $this->addVariable($var3);
        $this->addVariable($var4);
    }

}
?>
