<?php
/*
 * $Horde: whups/lib/Whups.php,v 1.16 2002/02/20 18:06:32 chuck Exp $
 *
 * Copyright 2001 Robert E. Coyle <robertecoyle@hotmail.com>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/bsdl.php.
 */

// WHUPS sections
$search = array(
    'fullname' => _("Search Tickets"),
    'title'    => _("Search Tickets"),
    'link'     => 'search.php'
);

$query = array(
    'fullname' => _("Query Tickets"),
    'title'    => _("Query Tickets"),
    'link'     => 'query.php'
);

$create = array(
    'fullname' => _("Create Ticket"),
    'title'    => _("Create Ticket"),
    'link'     => 'create.php'
);

$admin = array(
    'fullname' => _("Administration"),
    'title'    => _("Administration"),
    'link'     => 'admin.php'
);

$sections = array(
    'search' => $search,
    'query'  => $query,
    'create' => $create
);

if (@is_array($conf['auth']['admins']) && Auth::getAuth() && in_array(Auth::getAuth(), $conf['auth']['admins'])) {
    $sections['admin'] = $admin;
}

function format_time($timestamp) {
    $ago = (int)(floor((time() - $timestamp) / (60 * 60 * 24)));

    if ($ago == 0) {
        $ago = _(" (today)");
    } else if ($ago == 1) {
        $ago = _(" (yesterday)");
    } else {
        $ago = sprintf(_(" (%s days ago)"), $ago);
    }

    return strftime('%a %d %B', $timestamp) . $ago;
}

function format_time_full($timestamp) {
    $ago = (int) (floor((time() - $timestamp) / (60 * 60 * 24)));

    if ($ago == 0) {
        $ago = _(" (today)");
    } else if ($ago == 1) {
        $ago = _(" (yesterday)");
    } else {
        $ago = sprintf(_(" (%s days ago)"), $ago);
    }

    return strftime('%c', $timestamp) . $ago;
}

function preserveVarByGet($baseurl, $name, $value) {
    if (strchr($baseurl, '?'))
        $join = '&';
    else
        $join = '?';

    $baseurl .= $join . urlencode($name) . '=' . urlencode($value);

    return $baseurl;
}

function preserveVarByPost($name, $value) {
    $name  = htmlspecialchars($name);
    $value = htmlspecialchars($value);

    echo '<input type="hidden" name="' . $name . '" value="' . $value . "\" />\n";
}

function generateSelectOptions(&$values, $selectedValue) {
    $result = '';
    foreach ($values as $value => $display) {
        $selected = ($value == $selectedValue) ? ' selected="selected"' : '';
        $result .= " <option value=\"$value\"$selected>$display</option>\n";
    }

    return $result;
}

function generateCheckBoxes($name, $values, $checkedValues) {
    $result = '';
    if (!is_array($checkedValues)) {
        $checkedValues = array();
    }
    foreach ($values as $value => $display) {
        $checked = (in_array($value, $checkedValues)) ? ' checked="checked"' : '';
        $result .= "<input type=\"checkbox\" name=\"${name}[]\" value=\"$value\"$checked />&nbsp;$display<br />";
    }

    return $result;
}

function debug($text) {
    echo "<span class=\"debug\">$text</span>\n";
}

function getmicrotime() {
    $t = microtime();
    $t = explode(' ', $t);

    return ($t[1] + $t[0]);
}

// tee hee hee - I love functions like this
function useForms($forms) {
    foreach ($forms as $f) {
        eval("function &get$f(&\$v) {static \$f = ''; if (empty(\$f)) \$f = new $f(\$v); return \$f;}");
    }

    $func = "function &getForm(\$name, &\$v) { switch (strtolower(\$name)) {\n";

    foreach ($forms as $f) {
        $func .= "case '" . strtolower($f) . "': \$ret = &get$f(\$v); return \$ret;\n";
    }

    $func .= '}}';
    eval($func);
}

class Whups {

    function permissionsFilter($in, $filter)
    {
        global $conf, $registry;

        if (@is_array($conf['auth']['admins']) && in_array(Auth::getAuth(), $conf['auth']['admins'])) {
            return $in;
        }

        include_once HORDE_BASE . '/lib/Perms.php';
        $perms = &Perms::singleton();
        $out = array();
        $userID = Auth::getAuth();

        switch ($filter) {
        case 'module':
            foreach ($in as $moduleID => $name) {
                if ($perms->hasPermission('whups_module_' . $moduleID, $userID, _PERMS_READ)) {
                    $out[$moduleID] = $name;
                }
            }
            break;

        default:
            $out = $in;
        }
        
        return $out;
    }

}
?>
