<?php
// $Horde: whups/lib/api.php,v 1.10 2002/01/25 23:02:47 chuck Exp $
/*
 * Whups external API interface.
 *
 * This file defines Whups's external API interface. Other
 * applications can interact with Whups through this API.
 */

// Find the base file paths for Whups
@define('WHUPS_BASE', dirname(__FILE__) . '/..');

// Include the necessary libraries.
require_once WHUPS_BASE . '/lib/base.php';

function whupsListModules()
{
    return $GLOBALS['backend']->getModules();
}

function whupsAddModule($name)
{
    return $GLOBALS['backend']->addModule($name);
}

function whupsSummary()
{
    global $prefs, $registry, $backend;
    
    $html  = '<table border="0" cellpadding="2" cellspacing="0" width="100%"><tr><td class="header">';
    $html .= Horde::link(Horde::url($registry->getInitialPage()), $registry->getParam('name'), 'header') . $registry->getParam('name') . '</a>';
    $html .= '</td></tr><tr><td class="text"><table border="0" cellpadding="0" cellspacing="0">';
    
    $info = array('owner' => Auth::getAuth());
    $tickets = &$backend->getTicketsByProperties($info);
    if (count($tickets) > 0) {
        $html .= '<tr><td colspan="3" class="text"><b>' . _("Tickets assigned to you") . '</b></td></tr>';
        _listTickets($tickets, $html);
    }

    $info = array('requester' => Auth::getAuth());
    $tickets = &$backend->getTicketsByProperties($info);
    if (count($tickets) > 0) {
        $html .= '<tr><td colspan="3" class="text"><b>' . _("Tickets you requested") . '</b></td></tr>';
        _listTickets($tickets, $html);
    }

    $html .= '</table></td></tr></table>';
    
    return $html;
}

function _listTickets(&$tickets, &$html)
{
    foreach ($tickets as $ticket) {
        if (empty($ticket['summary'])) {
            $ticket['summary'] = _("<i>No summary</i>");
        }
        $ticket['summary'] = '[' . $ticket['id'] . '] ' . $ticket['summary'];
        $html .= '<tr><td class="text">' . Horde::link(Horde::applicationUrl('details.php?id=' . $ticket['id']), $ticket['summary']) . $ticket['summary'] . '</a></td>';
        $html .= '<td class="text">&nbsp;' . $ticket['_priority_name'] . '</td>';
        $html .= '<td class="text">&nbsp;' . $ticket['_state_name'] . '</td></tr>';
    }
}

?>
