<?php
/*
 * $Horde: whups/lib/base.php,v 1.16 2002/01/24 19:38:57 chuck Exp $
 *
 * Copyright 2001 Robert E. Coyle <robertecoyle@hotmail.com>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/bsdl.php.
 *
 * WHUPS base inclusion file.
 *
 * This file brings in all of the dependencies that every Whups script
 * will need, and sets up objects that all scripts use.
 */

// Find the base file path of Horde
@define('HORDE_BASE', dirname(__FILE__) . '/../..');

// Find the base file path of Whups
@define('WHUPS_BASE', dirname(__FILE__) . '/..');

// Registry
require_once HORDE_BASE . '/lib/Registry.php';
$registry = &Registry::singleton();
$registry->pushApp('whups');
$conf = &$GLOBALS['conf'];
@define('WHUPS_TEMPLATES', $registry->getParam('templates'));

// set error reporting according to config settings
error_reporting($conf['debug_level']);

// set max execution time according to config settings
set_time_limit($conf['max_exec_time']);

// Horde base libraries
require_once HORDE_BASE . '/lib/Horde.php';
require_once HORDE_BASE . '/lib/Auth.php';

// Whups base libraries
require_once WHUPS_BASE . '/lib/Whups.php';
require_once WHUPS_BASE . '/lib/WhupsVars.php';
require_once WHUPS_BASE . '/lib/Forms.php';
require_once WHUPS_BASE . '/lib/Query.php';
require_once WHUPS_BASE . '/lib/Driver.php';

// Driver
$GLOBALS['backend'] = &Whups_Driver::factory($conf['driver']['type'], $conf['driver']['dsn']);
$GLOBALS['backend']->initialise();

// Don't allow access unless there is a Horde login or guests are
// allowed.
if (!(Auth::getAuth() || $registry->allowGuests())) {
    header('Location: ' . Horde::url($registry->getParam('webroot', 'horde') . '/login.php?url=' . urlencode(Horde::selfUrl()), true));
    exit;
}

?>
