<?php
/*
 * $Horde: whups/search.php,v 1.16 2002/01/25 00:37:53 chuck Exp $
 *
 * Copyright 2001 Robert E. Coyle <robertecoyle@hotmail.com>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/bsdl.php.
 */

define('WHUPS_BASE', dirname(__FILE__));
require_once WHUPS_BASE . '/lib/base.php';
require_once WHUPS_BASE . '/lib/Search.php';

require WHUPS_TEMPLATES . '/common.inc';
require WHUPS_TEMPLATES . '/page.inc';
require WHUPS_TEMPLATES . '/headerbar.inc';
require WHUPS_TEMPLATES . '/formrenderer.inc';
require WHUPS_TEMPLATES . '/searchresults.inc';
require WHUPS_TEMPLATES . '/useractions.inc';

useForms(array(
    'SearchForm',
    'SearchNarrow1Form'));

$PAGE = new Page();
$HEADERBAR = new HeaderBar();
$RENDERER = new FormRenderer();

$beendone = 0;

$vars = &getDefaultVars();
$info = array();

// start the page
$PAGE->open(_("Search Tickets"));
$HEADERBAR->header($sections, 'search');
$HEADERBAR->actions($sections, 'search');

// what now?
$module = $vars->getVarWasset('module', $wasset);
$form = &getSearchForm($vars);

if ($wasset) {
    $dosearch = 1;
    $form->validate($vars);

    if ($form->isValid()) {
        $form->getInfo($vars, $info);

        if ($dosearch) {
            $values = array(
                _("Id")        => 'id',
                _("Summary")   => 'summary',
                _("State")     => '_state_name',
                _("Type")      => '_type_name',
                _("Priority")  => '_priority_name',
                _("Module")    => '_module_name',
                _("Timestamp") => 'timestamp'
                );

            $tickets = &$backend->getTicketsByProperties($info);
            $results = new SearchResults();

            $results->results($tickets, $values);

            $beendone = 1;
        }

        if (is_object($form)) {
            $form->open($RENDERER, $vars, 'search.php');

            $RENDERER->beginActive(_("Refine search"));
            $RENDERER->renderFormActive($form, $vars);
            $RENDERER->submit(_("Refine Search"));
            $RENDERER->end();
            $form->close($RENDERER);

            $beendone = 1;
        }
    }
}

if (!$beendone) {
    // front search page
    $ACTIONS = new UserActions();
    $mysearches = $backend->getUserSearches(Auth::getAuth());
    $ACTIONS->actions(_("My Searches"), $RENDERER, $mysearches);

    $form->open($RENDERER, $vars, 'search.php');
    $RENDERER->beginActive(_("Search Tickets"));
    $RENDERER->renderFormActive($form, $vars);
    $RENDERER->submit(_("Search"));
    $RENDERER->end();
    $form->close($RENDERER);
}

$PAGE->close();

?>
