<?php
/*
 * $Horde: whups/templates/actions.inc,v 1.2 2002/02/20 18:02:47 chuck Exp $
 *
 * Copyright 2001 Robert E. Coyle <robertecoyle@hotmail.com>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/bsdl.php.
 */

class Actions
{
    function Actions() {
	$this->actions  = array();
	$this->preserve = array();
    }

    function addAction($title, $link, $action = '') {
	$action = array('title' => $title, 'link' => $link, 'action' => $action);
	array_push($this->actions, $action);
    }

    function preserve($var, $value) {
	$preserve = array('var' => $var, 'value' => $value);
	array_push($this->preserve, $preserve);
    }

    function getTitleFromAction($action) {
	foreach ($this->actions as $ac) {
	    if ($ac['action'] == $action)
		return $ac['title'];
	}

	return null;
    }

    function render($active) {
?>
<table width="100%" cellspacing="0" cellpadding="0" border="0">
<tr class="menu"><td>
 <table width="100%" cellspacing="4" cellpadding="1" border="0">
  <tr>
<?php
        $width = 100.0 / sizeof($this->actions);

	foreach ($this->actions as $action) {
	    $class = 'sect';
	    $title = $action['title'];
	    $link = $action['link'];

	    foreach ($this->preserve as $preserve)
		$link = preserveVarByGet($link, $preserve['var'], $preserve['value']);

	    if (!empty($action['action'])) {
		$link  = preserveVarByGet($link, 'action', $action['action']);

		if ($active == $action['action'])
		    $class = 'cursect';
	    }

	    echo "   <td width=\"$width%\" align=\"center\" class=\"$class\">" . Horde::link(Horde::applicationUrl($link), $title) . $title . "</a></td>\n";
	}
?>
  </tr>
 </table>
</td></tr>
</table>

<br />

<?php
    }
}

?>
