<?php
/*
 * $Horde: whups/templates/queryrenderer.inc,v 1.3 2002/01/25 00:37:54 chuck Exp $
 *
 * Copyright 2001 Robert E. Coyle <robertecoyle@hotmail.com>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/bsdl.php.
 */

class QuerySetCurrentTypeRenderer extends CustomRenderer {
    function render(&$form, &$vars, $isActive) {
        global $backend;
?>
<table width="100%" cellspacing="0" cellpadding="0" border="0">
<tr class="item0"><td>
 <table width="100%" cellspacing="3" cellpadding="1" border="0">
  <tr class="item0">
   <td><b>Current Ticket Type:</b></td>
   <td><select><?= generateSelectOptions($backend->getAllTypes(), $vars->getVar('ttype')) ?></select></td>
   <td><input type="submit" value=<?= _("Change") ?> /></td>
   <td width="70%">&nbsp;</td>
  </tr>
 </table>
</td></tr>
</table>
<?php
    }
}

class QueryRenderer {

    function QueryRenderer()
    {
        global $backend;
        $this->ticketTypes = $backend->getAllTypes();
    }

    function renderActive(&$query, &$vars)
    {
        $this->_render($query, $vars, true);
    }

    function renderInactive(&$query, &$vars)
    {
        $this->_render($query, $vars, false);
    }

    function _render(&$query, &$vars, $active)
    {
        $this->currentRow  = 1;
        $this->isActive    = $active;
        $this->currentPath = $vars->getVar('path');

        $this->_renderBegin();
        // $query->walk($this, '_renderRow');
        $this->_renderEnd();
    }

    function edit(&$operations, $formname)
    {
?>
<tr><td class="item1">
 <select name="qaction" onchange="document.<?= $formname ?>.submit()">
<?php foreach ($operations as $value => $name) { ?>
  <option value="<?= $value ?>"><?= $name ?></option>
<?php } ?>
 </select>
</td></tr>
<?php
    }

    function _renderBegin()
    {
        // empty
    }

    function _renderRow(&$more, &$path, $type, $ttype, $criterion, $operator, $value)
    {
        global $backend;

        $this->currentRow++;

        $pathstring = Query::pathToString($path);

        $depth = count($path);
        $class = "item" . ($this->currentRow % 2);

        switch ($type) {
        case QUERY_TYPE_AND: $text = _("And"); break;
        case QUERY_TYPE_OR:  $text = _("Or");  break;
        case QUERY_TYPE_NOT: $text = _("Not"); break;
        case QUERY_TYPE_CRITERION:
            $ttypeName = $this->ticketTypes[$ttype];
            $text = "[$ttypeName] ";

            switch ($criterion) {
            case CRITERION_ID:             $text .= _("Id"); break;
            case CRITERION_MODULE:         $text .= _("Module"); break;
            case CRITERION_TYPE:           $text .= _("Type"); break;
            case CRITERION_CATEGORY:       $text .= _("Category"); break;
            case CRITERION_OWNER:          $text .= _("Owner"); break;
            case CRITERION_REQUESTER:      $text .= _("Requester"); break;
            case CRITERION_QA:             $text .= _("QA contact"); break;
            case CRITERION_CC:             $text .= _("CC list"); break;
            case CRITERION_ADDED_COMMENT:  $text .= _("Commentor"); break;
            case CRITERION_COMMENT:        $text .= _("Comment"); break;
            case CRITERION_SUMMARY:        $text .= _("Summary"); break;

                // the value of the following depend on ttype
            case CRITERION_STATE:
                $text .= _("State");
                echo $ttype;
                $value = $backend->getStateName($ttype, $value);
                break;

            case CRITERION_PRIORITY:
                $text .= _("Priority");
                $value = $backend->getPriorityName($ttype, $value);
                break;
            }

            $text .= ' ';

            switch ($operator) {
            case OPERATOR_GREATER:         $text .= _("is greater than"); break;
            case OPERATOR_LESS:            $text .= _("is less than"); break;
            case OPERATOR_EQUAL:           $text .= _("is"); break;
            case OPERATOR_CI_SUBSTRING:    $text .= _("contains (case insensitive) substring"); break;
            case OPERATOR_CS_SUBSTRING:    $text .= _("contains (case sensitive) substring"); break;
            case OPERATOR_WORD:            $text .= _("contains the word"); break;
            case OPERATOR_PATTERN:         $text .= _("matches the pattern"); break;
            }

            $text .= " $value";
            break;

        default:
            $text = sprintf(_("Unknown node type %s"), $type);
            break;
        }

        $space = '';
        $count = count($more);

        for ($i = 0; $i < $count - 1; $i++) {
            if ($more[$i] == 1) {
                $space .= Horde::img('/continue.gif', 'height="18" width="18"') . "\n";
            } else {
                $space .= Horde::img('/spacer.gif', 'height="18" width="18"') . "\n";
            }
        }

        if ($count > 0) {
            if ($more[$count - 1] == 1) {
                $space .= Horde::img('/middle.gif', 'height="18" width="18"') . "\n";
            } else {
                $space .= Horde::img('/last.gif', 'height="18" width="18"') . "\n";
            }
        }

        $extra  = ($this->isActive ? '' : ' disabled="disabled"');
        $extra .= ($pathstring == $this->currentPath ? ' checked="checked"' : '');
?>
 <tr><td class="<?= $class ?>">
  <input type="radio" name="path" value="<?= $pathstring ?>"<?= $extra ?>/>
  <?= $space ?>
  <?= $text ?>
 </td></tr>
<?php
    }

    function _renderEnd()
    {
        // empty
    }

}
?>
